<?php
    ini_set('display_errors', '1');
    ini_set('display_startup_errors', '1');
    ini_set('memory_limit', '512M');
    set_time_limit(0);
    error_reporting(E_ALL);
    require 'vendor/autoload.php';
    $conn= new mysqli('localhost',"urbex_developers", "kolkunzadeyeye1", "urbex_developers");
    
    use Google\ApiCore\ApiException;
    use Google\ApiCore\BidiStream;
    use Google\Cloud\Speech\V2\Client\SpeechClient;
    use Google\Cloud\Speech\V2\StreamingRecognizeRequest;
    use Google\Cloud\Speech\V2\StreamingRecognitionConfig;
    use Google\Cloud\Speech\V2\RecognitionConfig;
    use Google\Cloud\Speech\V2\AutoDetectDecodingConfig;
    use Google\Cloud\Speech\V2\ExplicitDecodingConfig;
    use Google\Cloud\Speech\V2\RecognitionFeatures;
    use Google\Cloud\Speech\V2\AudioEncoding;
    
    $projectId = "mediamonitor-455121";
    putenv('GOOGLE_APPLICATION_CREDENTIALS=' . __DIR__ . '/mediamonitor-455121-be3eb805f1d7.json');
    
    // Permanent storage directory structure
    $storageDir = __DIR__ . '/audio_archive/' . date('Y/m/d');
         if (!file_exists($storageDir)) {
        mkdir($storageDir, 0777, true); // Create directory with full permissions
    }
    
    // Current audio file
    $transcription_id = rand(10000, 99999) . uniqid() . time() . '.wav';
    $audioFile = $storageDir . '/' . $transcription_id;

    $ffmpegCommand = "ffmpeg -user_agent \"FFmpeg\" -re -i \"https://npr-ice.streamguys1.com/live.mp3\" -acodec pcm_s16le -ac 1 -ar 16000 -map 0:a -f tee \"[f=wav]pipe:1|[f=wav]$audioFile\"";
    $handle = popen($ffmpegCommand, "r");
    
    $streamInfo = shell_exec("ffprobe \"https://npr-ice.streamguys1.com/live.mp3\" -show_format -show_streams -print_format json");
    $metadata = json_decode($streamInfo, true);
    
    // print_r($metadata);
    $station_name = $metadata['format']['tags']['icy-name'];
    $programme_name = $metadata['format']['tags']['StreamTitle'];
    $station_url = $metadata['format']['filename'];

    try {
        $client = new SpeechClient(['transport' => 'grpc', 'credentials' => json_decode(file_get_contents(getenv('GOOGLE_APPLICATION_CREDENTIALS')), true)]);
    } catch (Exception $e) {
        echo 'Error: ' . $e->getMessage(); 
        exit;
    }
    
    try {
    $recognitionConfig = (new RecognitionConfig())
        ->setAutoDecodingConfig(new AutoDetectDecodingConfig())
        ->setLanguageCodes(['en-US', 'en-UK'])
        ->setModel('latest_long');
    } catch (Exception $e) {
        echo 'Error: ' . $e->getMessage(); 
        exit;
    }
    
    try {
        $streamConfig = (new StreamingRecognitionConfig())
        ->setConfig($recognitionConfig);
    } catch (Exception $e) {
        echo 'Error: ' . $e->getMessage();
        exit;
    }
    try {
        $configRequest = (new StreamingRecognizeRequest())
        ->setRecognizer("projects/$projectId/locations/global/recognizers/_")
        ->setStreamingConfig($streamConfig);
    } catch (Exception $e) {
        echo 'Error: ' . $e->getMessage(); 
        exit;
    }
    
    $stream = $client->streamingRecognize();
    $stream->write($configRequest);
    
    while (!feof($handle)) {
        $chunk = fread($handle, 8192); 
        if ($chunk !== false && strlen($chunk) > 0) {
            // print_r("listening to channel \n");
            try {
                $request = (new StreamingRecognizeRequest())
                        ->setAudio($chunk);
                    $stream->write($request);
            } catch (Exception $e) {
                var_dump('length_chunk_fail: ' . $e->getMessage());
            }
        } else {
            var_dump('length_chunk_null : '. $handle);
        }
    }
    
    
    try {
        $time = time();
        print_r("try_transcribe \n");
        foreach ($stream->closeWriteAndReadAll() as $response) {
            print_r("transcribing \n");
            foreach ($response->getResults() as $result) {
                foreach ($result->getAlternatives() as $alternative) {
                    $trans = mysqli_real_escape_string($conn, $alternative->getTranscript());
                    mysqli_query($conn, "INSERT INTO transcriptions (audio_id, transcript, station_name, programme_name, programme_url, state, streaming_server, time) VALUES ('$transcription_id', '$trans', '$station_name', '$programme_name', '$station_url', 'LAGOS', 'LOS-SVR-1', '$time')");
                    $trans_id = mysqli_insert_id($conn);
                    
                    // foreach ($alternative->getWords() as $wordInfo) {
                    //     $word = $wordInfo->getWord();
                    //     $mentioned = $wordInfo->getStartTime()->getSeconds();
                        
                    //     $sql = mysqli_query($conn, "SELECT * FROM lookout_words WHERE word = '$word'");
                    //     if (mysqli_num_rows($sql) > 0) {
                    //         mysqli_query($conn, "INSERT INTO lookout_word_found (transcript_id, word, time_mentioned) VALUES ('$trans_id', '$word', '$mentioned')");
                    //         echo "Word: " . $wordInfo->getWord() . PHP_EOL;
                    //         echo "Start Time: " . $wordInfo->getStartTime()->getSeconds() . "s" . PHP_EOL;
                    //         echo "End Time: " . $wordInfo->getEndTime()->getSeconds() . "s" . PHP_EOL;
                    //     }
                    // }
                }
            }
        }
    } catch (Google\ApiCore\ApiException $e) {
        if (strpos($e->getMessage(), "Stream timed out") !== false) {
            echo "Stream closed properly.\n";
        } else {
            throw $e;
        }
    } finally {
        
    }
    
    pclose($handle);
    $client->close();

?>