<?php
use Google\Cloud\Speech\V2\SpeechClient;
use Google\Cloud\Speech\V2\StreamingRecognitionConfig;
use Google\Cloud\Speech\V2\RecognitionConfig;
use Google\Cloud\Speech\V2\StreamingRecognizeRequest;

// Database Configuration
$conn= new mysqli('localhost',"urbex_developers", "kolkunzadeyeye1", "urbex_developers");
    
// Google Cloud Project ID
putenv('GOOGLE_APPLICATION_CREDENTIALS=' . __DIR__ . '/mediamonitor-455121-be3eb805f1d7.json');
$projectId = "your-google-project-id";

// Start Google Cloud Speech Client
try {
    $client = new SpeechClient(['transport' => 'grpc', 'credentials' => json_decode(file_get_contents(getenv('GOOGLE_APPLICATION_CREDENTIALS')), true)]);
} catch (Exception $e) {
    echo 'Error: ' . $e->getMessage(); 
    exit;
}

try {
    $streamingConfig = new StreamingRecognitionConfig([
        'config' => new RecognitionConfig([
            'language_codes' => ['en-US'],
            'model' => 'long',
            'auto_decoding_config' => []
        ])
    ]);
} catch (Exception $e) {
    echo 'Error: ' . $e->getMessage(); 
    exit;
}

// Command to capture live radio stream using ffmpeg
$radioUrl = "http://stream.live.vc.bbcmedia.co.uk/bbc_world_service";
$ffmpegCmd = "ffmpeg -i $radioUrl -f s16le -ac 1 -ar 24000 pipe:1";

// Open ffmpeg process
$handle = popen($ffmpegCmd, "r");
if (!$handle) {
    die("Failed to start ffmpeg process.");
}

// Start Streaming
try {
    $stream = $client->streamingRecognize();
    $stream->write(new StreamingRecognizeRequest([
        'streaming_config' => $streamingConfig
    ]));
} catch (Exception $e) {
    echo 'Error: ' . $e->getMessage(); 
    exit;
}

// Read audio from ffmpeg and send it to Google Cloud
while (!feof($handle)) {
    $chunk = fread($handle, 4096);
    if ($chunk === false) break;
    
    try {
        $stream->write(new StreamingRecognizeRequest([
            'audio' => $chunk
        ]));
    } catch (Exception $e) {
        echo 'Error: ' . $e->getMessage(); 
        exit;
    }
}

// Process transcription response
foreach ($stream->responses() as $response) {
    foreach ($response->getResults() as $result) {
        $transcript = $conn->real_escape_string($result->getAlternatives()[0]->getTranscript());
        $sql = "INSERT INTO transcriptions (transcript) VALUES ('$transcript')";
        $conn->query($sql);
        echo "Transcript: " . $transcript . PHP_EOL;
    }
}

// Close resources
pclose($handle);
$stream->close();
$client->close();
$conn->close();

?>
